class <%= @field.classify %> < ActiveRecord::Base
  include BlogDbConnect
  connect_to_db('<%= @name.pluralize %>')

  belongs_to :<%= @user_data['users']['name'] %>,
    class_name: '<%= @user_data['users']['name'].classify %>', foreign_key: 'user_id'
  has_many :<%= @user_data['attachments']['name'].pluralize %>,
    class_name: '<%= @user_data['attachments']['name'].classify %>', foreign_key: '<%= @name.singularize %>_id'
  has_many :<%= @user_data['comments']['name'].pluralize %>,
    class_name: '<%= @user_data['comments']['name'].classify %>', foreign_key: '<%= @name.singularize %>_id'

  def get_user_info
    user.to_json(only: [:email, :name])
  end

  def get_attachments
    attachments.to_json(only: [ :post_file_name, :post_content_type ])
  end

  def get_comments
    comments.to_json(only: [:comment])
  end

  def self.get_post(id)
    where(id: id).first.to_json(
      include: { user: { only: [:email, :name] }, comments: { only: [:comment] },
        attachments: { only: [ :post_file_name, :post_content_type ] } })
  end

  def self.by_tags(tag_name)
    Post.find_by_sql("SELECT posts.* FROM posts JOIN taggings posts_taggings
      ON posts_taggings.taggable_id = posts.id AND posts_taggings.taggable_type = 'Post'
      AND posts_taggings.tag_id = (select tags.id from tags where tags.name = '#{tag_name}')
      WHERE (posts.deleted_at IS NULL) ORDER BY created_at DESC")
  end
end
